Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 1 | #!/bin/bash -e |
| 2 | |
| 3 | # bootstrap.sh |
| 4 | |
| 5 | # Installs Salt and configure minimal SaltMaster or Minion to be used with: |
| 6 | # - http://github.com/salt-formulas-scripts |
| 7 | # - http://github.com/salt-formulas/salt-formula-salt (salt.master sls) |
| 8 | |
Petr Michalec | ca2471f | 2018-03-17 11:17:32 +0100 | [diff] [blame^] | 9 | # NOTE: This script is collection of shared functions to automate bootstrap of "salted" CI environments. |
| 10 | # Its not intended to be used in PRODUCTION unless you know what you are doing. |
| 11 | # You have been warned! |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 12 | |
| 13 | # Source specific env vars. |
| 14 | # shopt -u dotglob |
| 15 | export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass} |
| 16 | function source_local_envs() { |
Petr Michalec | b444ef9 | 2017-08-17 13:53:14 +0200 | [diff] [blame] | 17 | for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do |
Vasyl Saienko | 7a4161c | 2017-08-14 17:43:15 +0300 | [diff] [blame] | 18 | for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do |
| 19 | echo "Sourcing env variables from $f" |
| 20 | source $f |
| 21 | done |
| 22 | done |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 23 | } |
| 24 | source_local_envs |
| 25 | |
| 26 | ########################################## |
| 27 | # Set defaults env variables |
| 28 | |
| 29 | if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then |
| 30 | set -x |
| 31 | SALT_LOG_LEVEL="--state-verbose=true -ldebug" |
| 32 | fi |
| 33 | |
| 34 | export MAGENTA='\033[0;95m' |
| 35 | export YELLOW='\033[1;33m' |
| 36 | export BLUE='\033[0;35m' |
| 37 | export CYAN='\033[0;96m' |
| 38 | export RED='\033[0;31m' |
| 39 | export NC='\033[0m' # No Color' |
| 40 | |
| 41 | export LC_ALL=C |
| 42 | export SALT_LOG_LEVEL="--state-verbose=false -lerror" |
| 43 | export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }" |
| 44 | export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 45 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 46 | # salt apt repository |
| 47 | test -e /etc/lsb-release && eval $(cat /etc/lsb-release) |
| 48 | which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)} |
| 49 | # |
Dmitry Ukov | 95492a0 | 2017-10-23 11:34:45 +0400 | [diff] [blame] | 50 | export APT_REPOSITORY=${APT_REPOSITORY:- deb [arch=amd64] http://apt.mirantis.com/${DISTRIB_CODENAME} ${DISTRIB_REVISION:-stable} salt} |
chnyda | 30c07a6 | 2017-09-20 14:28:02 +0200 | [diff] [blame] | 51 | export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://apt.mirantis.com/public.gpg} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 52 | # reclass |
| 53 | export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git |
ibumarskov | f72e05e | 2017-11-29 14:37:48 +0300 | [diff] [blame] | 54 | export RECLASS_BRANCH=${RECLASS_BRANCH:-master} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 55 | |
| 56 | # formula |
| 57 | export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas} |
| 58 | export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas} |
| 59 | export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master} |
| 60 | export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git |
Petr Michalec | 515356f | 2017-11-16 11:20:20 +0100 | [diff] [blame] | 61 | # Essential set of formulas (known to by used on cfg01 node for most setups during bootsrap) |
| 62 | # DEPRECATED: FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS maas memcached ntp nginx collectd sensu heka sphinx mysql grafana libvirt rsyslog glusterfs postfix xtrabackup freeipa prometheus telegraf elasticsearch kibana rundeck devops-portal rsync docker keepalived aptly jenkins gerrit artifactory influxdb horizon} |
Petr Michalec | e07cd0b | 2017-11-15 11:41:57 +0100 | [diff] [blame] | 63 | FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 64 | # minimal set of formulas for salt-master bootstrap |
Petr Michalec | 515356f | 2017-11-16 11:20:20 +0100 | [diff] [blame] | 65 | declare -a FORMULAS_SALT_MASTER=(reclass salt git openssh linux $(echo $FORMULAS_SALT_MASTER)) |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 66 | export FORMULAS_SALT_MASTER |
| 67 | |
| 68 | # system / host |
Petr Michalec | c749e86 | 2017-09-06 21:10:10 +0200 | [diff] [blame] | 69 | export HOSTNAME=${HOSTNAME:-`hostname -s`} |
| 70 | export HOSTNAME=${HOSTNAME//.*/} |
| 71 | export DOMAIN=${DOMAIN:-`hostname -d`} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 72 | export DOMAIN=${DOMAIN:-bootstrap.local} |
| 73 | |
| 74 | # salt |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 75 | export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}} |
Petr Michalec | 2e3a499 | 2017-08-17 14:20:43 +0200 | [diff] [blame] | 76 | export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 77 | |
| 78 | # saltstack |
Petr Michalec | 33c0489 | 2017-09-08 15:10:30 +0200 | [diff] [blame] | 79 | BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True} |
alexz | 0adc271 | 2018-02-11 17:33:52 +0100 | [diff] [blame] | 80 | BOOTSTRAP_SALTSTACK_COM=${BOOTSTRAP_SALTSTACK_COM:-"https://bootstrap.saltstack.com"} |
Petr Michalec | e11cf61 | 2017-09-08 18:21:48 +0200 | [diff] [blame] | 81 | BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION:- stable 2016.3 } |
Jakub Josef | 0b61174 | 2018-01-09 17:02:01 +0100 | [diff] [blame] | 82 | BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION//latest*/stable} |
alexz | 0adc271 | 2018-02-11 17:33:52 +0100 | [diff] [blame] | 83 | # TODO add 'r' option by default |
| 84 | # Currently, without 'r' option, upstream saltstack repos will be used. Otherwise |
| 85 | # local one should be used, from http://apt.mirantis.com/ or whatever. |
Petr Michalec | 33c0489 | 2017-09-08 15:10:30 +0200 | [diff] [blame] | 86 | BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX $BOOTSTRAP_SALTSTACK_VERSION } |
Petr Michalec | e11cf61 | 2017-09-08 18:21:48 +0200 | [diff] [blame] | 87 | SALT_SOURCE=${SALT_SOURCE:-pkg} |
| 88 | # the version below is used salt pillar data |
| 89 | SALT_VERSION=${SALT_VERSION:-latest} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 90 | |
Petr Michalec | ca2471f | 2018-03-17 11:17:32 +0100 | [diff] [blame^] | 91 | # SECURITY |
| 92 | SSH_STRICTHOSTKEYCHECKING=no |
| 93 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 94 | # environment |
| 95 | if [ "$FORMULAS_SOURCE" == "git" ]; then |
| 96 | SALT_ENV=${SALT_ENV:-dev} |
| 97 | elif [ "$FORMULAS_SOURCE" == "pkg" ]; then |
| 98 | SALT_ENV=${SALT_ENV:-prd} |
| 99 | fi |
Petr Michalec | 05b5245 | 2017-09-08 14:26:59 +0200 | [diff] [blame] | 100 | eval "$(grep -h '=' /etc/*release 2> /dev/null)" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 101 | PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z) |
| 102 | case $PLATFORM_FAMILY in |
| 103 | debian ) |
| 104 | PKGTOOL="$SUDO apt-get" |
| 105 | test ${VERSION_ID//\.*/} -ge 16 && { |
| 106 | SVCTOOL=service |
| 107 | } || { SVCTOOL=service |
| 108 | } |
| 109 | ;; |
| 110 | rhel ) |
| 111 | PKGTOOL="$SUDO yum" |
| 112 | test ${VERSION_ID//\.*/} -ge 7 && { |
| 113 | SVCTOOL=systemctl |
| 114 | } || { SVCTOOL=service |
| 115 | } |
| 116 | ;; |
| 117 | esac |
| 118 | |
| 119 | export PLATFORM_FAMILY |
| 120 | export PKGTOOL |
| 121 | export SVCTOOL |
| 122 | |
| 123 | ########################################## |
| 124 | # FUNCTIONS |
| 125 | |
| 126 | log_info() { |
| 127 | echo -e "${YELLOW}[INFO] $* ${NC}" |
| 128 | } |
| 129 | |
| 130 | log_warn() { |
| 131 | echo -e "${MAGENTA}[WARN] $* ${NC}" |
| 132 | } |
| 133 | |
Petr Michalec | 24b30e8 | 2017-08-21 10:59:18 +0200 | [diff] [blame] | 134 | log_debug() { |
| 135 | echo -e "${CYAN}[WARN] $* ${NC}" |
| 136 | } |
| 137 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 138 | log_err() { |
| 139 | echo -e "${RED}[ERROR] $* ${NC}" >&2 |
| 140 | } |
| 141 | |
| 142 | configure_pkg_repo() |
| 143 | { |
| 144 | |
| 145 | case $PLATFORM_FAMILY in |
| 146 | debian) |
| 147 | if [ -n "$APT_REPOSITORY_PPA" ]; then |
| 148 | which add-apt-repository || $SUDO apt-get install -y software-properties-common |
| 149 | $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA} |
| 150 | else |
Mykyta Karpin | fbcb548 | 2017-10-04 14:15:25 +0300 | [diff] [blame] | 151 | echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/mcp_salt.list >/dev/null |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 152 | curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add - |
| 153 | fi |
| 154 | $SUDO apt-get clean |
| 155 | $SUDO apt-get update |
| 156 | ;; |
| 157 | rhel) |
| 158 | $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm |
| 159 | $SUDO yum clean all |
| 160 | ;; |
| 161 | esac |
| 162 | |
| 163 | } |
| 164 | |
| 165 | _atexit() { |
| 166 | RETVAL=$? |
| 167 | trap true INT TERM EXIT |
| 168 | |
| 169 | if [ $RETVAL -ne 0 ]; then |
| 170 | log_err "Execution failed" |
| 171 | else |
| 172 | log_info "Execution successful" |
| 173 | fi |
| 174 | return $RETVAL |
| 175 | } |
| 176 | |
| 177 | retry() { |
| 178 | local tries |
| 179 | if [[ $1 =~ ^[0-9]+$ ]]; then |
| 180 | tries=$1; shift |
| 181 | else |
| 182 | tries=3 |
| 183 | fi |
Petr Michalec | 262e3ad | 2017-10-06 13:41:58 +0200 | [diff] [blame] | 184 | ret=1 |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 185 | for i in $(seq 1 $tries); do |
Petr Michalec | 262e3ad | 2017-10-06 13:41:58 +0200 | [diff] [blame] | 186 | "$@" && return $? || ret=$? |
| 187 | sleep $i |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 188 | done |
Petr Michalec | 9fec8b3 | 2017-10-05 14:46:42 +0200 | [diff] [blame] | 189 | return $ret |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 190 | } |
| 191 | |
| 192 | function clone_reclass() { |
Petr Michalec | a361d4e | 2017-09-08 11:38:16 +0200 | [diff] [blame] | 193 | if [ ! -d ${RECLASS_ROOT}/classes ]; then |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 194 | # No reclass at all, clone from given address |
alexz | 0adc271 | 2018-02-11 17:33:52 +0100 | [diff] [blame] | 195 | # In case, non-github repo |
| 196 | _tmp_host=$(echo ${RECLASS_ADDRESS} | awk -F/ '{print $3}') |
| 197 | ssh-keyscan -T 1 -H ${_tmp_host} >> ~/.ssh/known_hosts || true |
| 198 | # But, awk is not perfect solution, so lets make double-check for github |
| 199 | ssh-keyscan -T 1 -H github.com >> ~/.ssh/known_hosts || true |
ibumarskov | f72e05e | 2017-11-29 14:37:48 +0300 | [diff] [blame] | 200 | if echo ${RECLASS_BRANCH} | egrep -q "^refs"; then |
| 201 | git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT} |
| 202 | cd ${RECLASS_ROOT} |
| 203 | git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH} && git checkout FETCH_HEAD |
| 204 | export RECLASS_REVISION=$(git rev-parse HEAD) |
| 205 | cd - |
| 206 | else |
| 207 | git clone -b ${RECLASS_BRANCH} ${RECLASS_ADDRESS} ${RECLASS_ROOT}; |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 208 | fi; |
| 209 | fi; |
Petr Michalec | 679f15b | 2017-09-18 16:16:29 +0200 | [diff] [blame] | 210 | if [ ! -d ${RECLASS_ROOT}/classes ]; then |
Petr Michalec | a361d4e | 2017-09-08 11:38:16 +0200 | [diff] [blame] | 211 | log_err "Reclass ${RECLASS_ROOT} is not fetched locally;" |
| 212 | ls -Rla ${RECLASS_ROOT} |
| 213 | exit 1 |
| 214 | fi; |
| 215 | $SUDO mkdir -p $RECLASS_ROOT/classes/service |
| 216 | $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 217 | } |
| 218 | |
| 219 | |
| 220 | ########################################## |
| 221 | # Main calls |
| 222 | |
Petr Michalec | ca2471f | 2018-03-17 11:17:32 +0100 | [diff] [blame^] | 223 | ci_config_ssh() { |
| 224 | |
| 225 | # for CI current user |
| 226 | conf=~/.ssh/config |
| 227 | mkdir -p $(dirname $conf) |
| 228 | touch $conf |
| 229 | echo -e "Host *\n\tStrictHostKeyChecking $SSH_STRICTHOSTKEYCHECKING\n" | tee -a $conf >/dev/null |
| 230 | touch ~/.ssh/known_hosts |
| 231 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 232 | if ! grep github.com ~/.ssh/known_hosts; then |
| 233 | ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true |
Petr Michalec | ca2471f | 2018-03-17 11:17:32 +0100 | [diff] [blame^] | 234 | ssh-keyscan -H gitlab.com >> ~/.ssh/known_hosts || true |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 235 | fi |
Petr Michalec | ca2471f | 2018-03-17 11:17:32 +0100 | [diff] [blame^] | 236 | |
| 237 | # for root |
| 238 | #conf=/root/.ssh/config |
| 239 | #$SUDO mkdir -p $(dirname $conf) |
| 240 | #$SUDO touch $conf |
| 241 | #if ! $SSH_STRICTHOSTKEYCHECKING; then |
| 242 | # echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee -a $conf >/dev/null |
| 243 | #fi |
| 244 | } |
| 245 | |
| 246 | # DEPRECATED |
| 247 | system_config_ssh_conf() { |
| 248 | # for backward compatibility |
| 249 | ci_config_ssh |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 250 | } |
| 251 | |
| 252 | system_config_salt_modules_prereq() { |
| 253 | # salt-formulas custom modules dependencies, etc: |
| 254 | $SUDO $PKGTOOL install -y iproute2 curl sudo apt-transport-https python-psutil python-apt python-m2crypto python-oauth python-pip &>/dev/null |
| 255 | } |
| 256 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 257 | system_config_minion() { |
| 258 | log_info "System configuration salt minion" |
| 259 | } |
| 260 | |
| 261 | system_config_master() { |
| 262 | log_info "System configuration salt master" |
| 263 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 264 | system_config_salt_modules_prereq |
Petr Michalec | ca2471f | 2018-03-17 11:17:32 +0100 | [diff] [blame^] | 265 | ci_config_ssh |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 266 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 267 | if ! grep '127.0.1.2.*salt' /etc/hosts; then |
| 268 | echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null |
| 269 | fi |
Petr Michalec | bebd7d5 | 2018-03-16 22:14:05 +0100 | [diff] [blame] | 270 | |
| 271 | # DEPRECATED, should be removed or moved to salt master specific function |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 272 | which reclass-salt || { |
| 273 | test -e /usr/share/reclass/reclass-salt && { |
| 274 | ln -fs /usr/share/reclass/reclass-salt /usr/bin |
| 275 | } |
| 276 | } |
| 277 | } |
| 278 | |
| 279 | configure_salt_master() |
| 280 | { |
| 281 | |
| 282 | echo "Configuring salt-master ..." |
| 283 | |
Petr Michalec | 4be5e5b | 2017-08-17 11:44:49 +0200 | [diff] [blame] | 284 | if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then |
Petr Michalec | 29d3ea3 | 2017-10-31 17:22:36 +0100 | [diff] [blame] | 285 | read -d '' IGNORE_CLASS_NOTFOUND <<-EOF |
| 286 | ignore_class_notfound: True |
| 287 | ignore_class_regexp: |
| 288 | - 'service.*' |
| 289 | EOF |
Petr Michalec | 4be5e5b | 2017-08-17 11:44:49 +0200 | [diff] [blame] | 290 | fi |
| 291 | |
Petr Michalec | dd1a047 | 2017-09-06 19:27:24 +0200 | [diff] [blame] | 292 | # to force alternative reclass module path |
Petr Michalec | d9d0a32 | 2017-09-06 19:38:32 +0200 | [diff] [blame] | 293 | if [ -n "$RECLASS_SOURCE_PATH" ]; then |
| 294 | RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}" |
| 295 | else |
| 296 | RECLASS_SOURCE_PATH="" |
| 297 | fi |
Petr Michalec | dd1a047 | 2017-09-06 19:27:24 +0200 | [diff] [blame] | 298 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 299 | [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d |
| 300 | cat <<-EOF > /etc/salt/master.d/master.conf |
| 301 | file_roots: |
| 302 | base: |
| 303 | - /usr/share/salt-formulas/env |
| 304 | prd: |
| 305 | - /srv/salt/env/prd |
| 306 | dev: |
| 307 | - /srv/salt/env/dev |
| 308 | pillar_opts: False |
| 309 | open_mode: True |
| 310 | reclass: &reclass |
| 311 | storage_type: yaml_fs |
| 312 | inventory_base_uri: ${RECLASS_ROOT} |
Petr Michalec | 4be5e5b | 2017-08-17 11:44:49 +0200 | [diff] [blame] | 313 | ${IGNORE_CLASS_NOTFOUND} |
Petr Michalec | dd1a047 | 2017-09-06 19:27:24 +0200 | [diff] [blame] | 314 | ${RECLASS_SOURCE_PATH} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 315 | ext_pillar: |
| 316 | - reclass: *reclass |
| 317 | master_tops: |
| 318 | reclass: *reclass |
| 319 | EOF |
| 320 | |
| 321 | echo "Configuring reclass ..." |
| 322 | |
| 323 | [ ! -d /etc/reclass ] && mkdir /etc/reclass |
| 324 | cat <<-EOF > /etc/reclass/reclass-config.yml |
| 325 | storage_type: yaml_fs |
| 326 | pretty_print: True |
| 327 | output: yaml |
| 328 | inventory_base_uri: ${RECLASS_ROOT} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 329 | EOF |
| 330 | |
| 331 | clone_reclass |
| 332 | # override some envs from cluster level *.env, use with care |
| 333 | source_local_envs |
| 334 | |
| 335 | cd ${RECLASS_ROOT} |
| 336 | if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then |
| 337 | # Possibly subrepo checkout needed |
| 338 | git submodule update --init --recursive |
| 339 | fi |
| 340 | |
Petr Michalec | 212cc6a | 2017-08-17 21:39:40 +0200 | [diff] [blame] | 341 | mkdir -vp ${RECLASS_ROOT}/nodes/_generated |
Petr Michalec | 51ece84 | 2017-09-06 20:44:15 +0200 | [diff] [blame] | 342 | rm -rvf ${RECLASS_ROOT}/nodes/_generated/* |
| 343 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 344 | CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1) |
Petr Michalec | 212cc6a | 2017-08-17 21:39:40 +0200 | [diff] [blame] | 345 | CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 346 | if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then |
Petr Michalec | 24b30e8 | 2017-08-21 10:59:18 +0200 | [diff] [blame] | 347 | log_warn "Salt Master node specification has not been found in model." |
| 348 | log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 349 | cat <<-EOF > ${CONFIG} |
| 350 | classes: |
Petr Michalec | d81d1f5 | 2017-08-17 20:18:06 +0200 | [diff] [blame] | 351 | - cluster.${CLUSTER_NAME}.infra.config |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 352 | parameters: |
| 353 | _param: |
Petr Michalec | a7de6df | 2017-08-31 12:16:57 +0200 | [diff] [blame] | 354 | salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 355 | salt_master_base_environment: $SALT_ENV |
Petr Michalec | d81d1f5 | 2017-08-17 20:18:06 +0200 | [diff] [blame] | 356 | salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master} |
ibumarskov | f72e05e | 2017-11-29 14:37:48 +0300 | [diff] [blame] | 357 | reclass_data_revision: ${RECLASS_REVISION:-$RECLASS_BRANCH} |
Petr Michalec | d81d1f5 | 2017-08-17 20:18:06 +0200 | [diff] [blame] | 358 | reclass_data_repository: "$RECLASS_ADDRESS" |
Petr Michalec | a7de6df | 2017-08-31 12:16:57 +0200 | [diff] [blame] | 359 | reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME} |
Petr Michalec | d81d1f5 | 2017-08-17 20:18:06 +0200 | [diff] [blame] | 360 | linux_system_codename: ${DISTRIB_CODENAME} |
| 361 | cluster_name: ${CLUSTER_NAME} |
| 362 | cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 363 | linux: |
| 364 | system: |
Petr Michalec | d81d1f5 | 2017-08-17 20:18:06 +0200 | [diff] [blame] | 365 | name: ${HOSTNAME:-cfg01} |
| 366 | domain: ${DOMAIN:-$CLUSTER_NAME.local} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 367 | # ######## |
| 368 | EOF |
| 369 | |
| 370 | if [ "$SALT_VERSION" == "latest" ]; then |
| 371 | VERSION="" |
| 372 | else |
| 373 | VERSION="version: $SALT_VERSION" |
| 374 | fi |
| 375 | |
| 376 | cat <<-EOF >> ${CONFIG} |
| 377 | salt: |
| 378 | master: |
| 379 | accept_policy: open_mode |
| 380 | source: |
| 381 | engine: $SALT_SOURCE |
| 382 | $VERSION |
| 383 | minion: |
| 384 | source: |
| 385 | engine: $SALT_SOURCE |
| 386 | $VERSION |
| 387 | # ######## |
| 388 | # vim: ft=yaml sw=2 ts=2 sts=2 |
| 389 | EOF |
| 390 | fi |
Petr Michalec | 24b30e8 | 2017-08-21 10:59:18 +0200 | [diff] [blame] | 391 | |
| 392 | log_debug "Salt Master node config yaml:" |
| 393 | log_debug "$(cat ${CONFIG})" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 394 | } |
| 395 | |
| 396 | configure_salt_minion() |
| 397 | { |
| 398 | [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d |
| 399 | cat <<-EOF > /etc/salt/minion.d/minion.conf |
Petr Michalec | a7de6df | 2017-08-31 12:16:57 +0200 | [diff] [blame] | 400 | master: ${MASTER_IP:-$MASTER_HOSTNAME} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 401 | id: $MINION_ID |
| 402 | EOF |
| 403 | } |
| 404 | |
Petr Michalec | a6cd2bd | 2017-09-07 16:59:19 +0200 | [diff] [blame] | 405 | install_reclass() |
| 406 | { |
| 407 | VERSION=${1:-$RECLASS_VERSION} |
Petr Michalec | 372fa03 | 2017-11-15 17:36:19 +0100 | [diff] [blame] | 408 | VERSION=${VERSION:-pkg} |
Petr Michalec | 800dd07 | 2017-11-15 17:19:26 +0100 | [diff] [blame] | 409 | case ${VERSION} in |
| 410 | pkg|package) |
| 411 | which reclass || $SUDO $PKGTOOL install -y reclass |
| 412 | ;; |
| 413 | *) |
Petr Michalec | 981f3cc | 2017-11-15 17:40:31 +0100 | [diff] [blame] | 414 | log_warn "Install development version of reclass" |
Petr Michalec | 1b37d3d | 2017-11-15 18:20:46 +0100 | [diff] [blame] | 415 | # Note: dev/git/pip version... |
| 416 | # It replaces all local reclass versions on system |
| 417 | # Required for reclass/git features: |
| 418 | # $SUDO $PKGTOOL install -y libffi-dev libgit2-dev || true |
Petr Michalec | 800dd07 | 2017-11-15 17:19:26 +0100 | [diff] [blame] | 419 | for s in $(python -c "import site; print(' '.join(site.getsitepackages()))"); do |
Petr Michalec | 2302083 | 2017-11-15 17:34:49 +0100 | [diff] [blame] | 420 | sudo -H pip install --install-option="--prefix=" --upgrade --force-reinstall -I \ |
Petr Michalec | 800dd07 | 2017-11-15 17:19:26 +0100 | [diff] [blame] | 421 | -t "$s" git+https://github.com/salt-formulas/reclass.git@${VERSION}; |
| 422 | done |
| 423 | ;; |
| 424 | esac |
Petr Michalec | a6cd2bd | 2017-09-07 16:59:19 +0200 | [diff] [blame] | 425 | } |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 426 | |
| 427 | install_salt_master_pkg() |
| 428 | { |
| 429 | echo -e "\nPreparing base OS repository ...\n" |
| 430 | |
| 431 | configure_pkg_repo |
| 432 | |
| 433 | echo -e "\nInstalling salt master ...\n" |
| 434 | |
| 435 | case $PLATFORM_FAMILY in |
| 436 | debian) |
| 437 | $SUDO apt-get install -y git |
alexz | 0adc271 | 2018-02-11 17:33:52 +0100 | [diff] [blame] | 438 | curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 439 | ;; |
| 440 | rhel) |
| 441 | yum install -y git |
alexz | 0adc271 | 2018-02-11 17:33:52 +0100 | [diff] [blame] | 442 | curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 443 | ;; |
| 444 | esac |
Jakub Josef | 0b61174 | 2018-01-09 17:02:01 +0100 | [diff] [blame] | 445 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 446 | which reclass-salt || { |
| 447 | test -e /usr/share/reclass/reclass-salt && { |
| 448 | ln -fs /usr/share/reclass/reclass-salt /usr/bin |
| 449 | } |
| 450 | } |
| 451 | |
| 452 | configure_salt_master |
| 453 | |
| 454 | echo -e "\nRestarting services ...\n" |
| 455 | [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub |
| 456 | $SVCTOOL salt-master restart |
| 457 | } |
| 458 | |
| 459 | install_salt_master_pip() |
| 460 | { |
| 461 | echo -e "\nPreparing base OS repository ...\n" |
| 462 | |
| 463 | case $PLATFORM_FAMILY in |
| 464 | debian) |
| 465 | $SUDO apt-get install -y python-pip python-dev zlib1g-dev git |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 466 | ;; |
| 467 | rhel) |
| 468 | $SUDO yum install -y git |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 469 | ;; |
| 470 | esac |
| 471 | |
| 472 | echo -e "\nInstalling salt master ...\n" |
| 473 | # TODO: replace with saltstack bootstrap script |
Jakub Josef | 0b61174 | 2018-01-09 17:02:01 +0100 | [diff] [blame] | 474 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 475 | if [ "$SALT_VERSION" == "latest" ]; then |
| 476 | pip install salt |
| 477 | else |
| 478 | pip install salt==$SALT_VERSION |
| 479 | fi |
| 480 | |
| 481 | curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master |
| 482 | ln -s /usr/local/bin/salt-master /usr/bin/salt-master |
| 483 | |
| 484 | which reclass-salt || { |
| 485 | test -e /usr/share/reclass/reclass-salt && { |
| 486 | ln -fs /usr/share/reclass/reclass-salt /usr/bin |
| 487 | } |
| 488 | } |
| 489 | |
| 490 | configure_salt_master |
| 491 | |
| 492 | echo -e "\nRestarting services ...\n" |
| 493 | [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub |
| 494 | $SVCTOOL salt-master restart |
| 495 | } |
| 496 | |
| 497 | |
| 498 | |
| 499 | install_salt_minion_pkg() |
| 500 | { |
| 501 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 502 | echo -e "\nInstalling salt minion ...\n" |
| 503 | |
| 504 | case $PLATFORM_FAMILY in |
| 505 | debian) |
alexz | 0adc271 | 2018-02-11 17:33:52 +0100 | [diff] [blame] | 506 | curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 507 | ;; |
| 508 | rhel) |
alexz | 0adc271 | 2018-02-11 17:33:52 +0100 | [diff] [blame] | 509 | curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 510 | ;; |
| 511 | esac |
| 512 | |
| 513 | |
| 514 | configure_salt_minion |
Petr Michalec | 3b7fdd8 | 2017-09-08 15:35:56 +0200 | [diff] [blame] | 515 | #$SVCTOOL salt-minion restart |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 516 | } |
| 517 | |
| 518 | install_salt_minion_pip() |
| 519 | { |
| 520 | echo -e "\nInstalling salt minion ...\n" |
| 521 | |
| 522 | curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion |
| 523 | ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion |
| 524 | |
| 525 | configure_salt_minion |
Petr Michalec | 3b7fdd8 | 2017-09-08 15:35:56 +0200 | [diff] [blame] | 526 | #$SVCTOOL salt-minion restart |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 527 | } |
| 528 | |
| 529 | |
| 530 | install_salt_formula_pkg() |
| 531 | { |
| 532 | configure_pkg_repo |
| 533 | |
| 534 | case $PLATFORM_FAMILY in |
| 535 | debian) |
| 536 | echo "Configuring necessary formulas ..." |
| 537 | |
| 538 | [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service |
| 539 | # Set essentials if FORMULAS_SALT_MASTER is not defined at all |
Petr Michalec | 2d75397 | 2017-11-30 16:24:37 +0100 | [diff] [blame] | 540 | [ -z ${FORMULAS_SALT_MASTER} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached") |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 541 | for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do |
| 542 | echo -e "\nConfiguring salt formula ${formula_service} ...\n" |
| 543 | [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \ |
| 544 | if ! $SUDO apt-get install -y salt-formula-${formula_service}; then |
| 545 | echo -e "\nInstall salt-formula-${formula_service} failed.\n" |
| 546 | exit 1 |
| 547 | fi |
| 548 | [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \ |
| 549 | ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service} |
| 550 | done |
| 551 | ;; |
| 552 | rhel) |
| 553 | # TODO |
| 554 | ;; |
| 555 | esac |
| 556 | |
| 557 | [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo "" |
| 558 | [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo "" |
| 559 | } |
| 560 | |
| 561 | install_salt_formula_git() |
| 562 | { |
| 563 | echo "Configuring necessary formulas ..." |
| 564 | |
| 565 | [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service |
| 566 | # Set essentials if FORMULAS_SALT_MASTER is not defined at all |
Petr Michalec | 2d75397 | 2017-11-30 16:24:37 +0100 | [diff] [blame] | 567 | [ -z ${FORMULAS_SALT_MASTER} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached") |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 568 | for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do |
| 569 | echo -e "\nConfiguring salt formula ${formula_service} ...\n" |
| 570 | _BRANCH=${FORMULAS_BRANCH} |
| 571 | [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && { |
| 572 | if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then |
| 573 | # Fallback to the master branch if the branch doesn't exist for this repository |
| 574 | _BRANCH=master |
| 575 | fi |
| 576 | if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then |
| 577 | echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n" |
| 578 | exit 1 |
| 579 | fi |
| 580 | } || { |
| 581 | cd ${FORMULAS_PATH}/env/_formulas/${formula_service}; |
| 582 | git fetch origin/${_BRANCH} || git fetch --all |
| 583 | git checkout ${_BRANCH} && git pull || git pull; |
| 584 | cd - |
| 585 | } |
| 586 | [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \ |
| 587 | ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service} |
| 588 | [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \ |
| 589 | ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service} |
| 590 | done |
| 591 | |
| 592 | [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo "" |
| 593 | [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo "" |
| 594 | } |
| 595 | |
Petr Michalec | e9c8452 | 2017-12-13 17:14:08 +0100 | [diff] [blame] | 596 | saltservice_stop() { |
Petr Michalec | dd646db | 2017-12-18 15:56:18 +0100 | [diff] [blame] | 597 | set +e |
Petr Michalec | e9c8452 | 2017-12-13 17:14:08 +0100 | [diff] [blame] | 598 | $SUDO service salt-minion stop |
| 599 | $SUDO service salt-master stop |
| 600 | sleep ${SALT_STOPSTART_WAIT:-30} |
Petr Michalec | 7822efe | 2017-12-15 16:19:32 +0100 | [diff] [blame] | 601 | ${SUDO} pkill -9 salt-master && ${SUDO} rm -rf /var/run/salt/master/* || true |
Petr Michalec | e9c8452 | 2017-12-13 17:14:08 +0100 | [diff] [blame] | 602 | ${SUDO} pkill -9 salt-minion |
| 603 | } |
| 604 | saltservice_start() { |
Petr Michalec | dd646db | 2017-12-18 15:56:18 +0100 | [diff] [blame] | 605 | set +e |
Petr Michalec | e9c8452 | 2017-12-13 17:14:08 +0100 | [diff] [blame] | 606 | $SUDO service salt-master start |
| 607 | $SUDO service salt-minion start |
| 608 | sleep ${SALT_STOPSTART_WAIT:-30} |
| 609 | } |
| 610 | |
| 611 | saltservice_restart() { |
Petr Michalec | dd646db | 2017-12-18 15:56:18 +0100 | [diff] [blame] | 612 | set +e |
Petr Michalec | e9c8452 | 2017-12-13 17:14:08 +0100 | [diff] [blame] | 613 | saltservice_stop |
| 614 | saltservice_start |
| 615 | } |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 616 | |
| 617 | saltmaster_bootstrap() { |
| 618 | |
| 619 | log_info "Salt master setup" |
| 620 | test -n "$MASTER_HOSTNAME" || exit 1 |
| 621 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 622 | # override some envs from cluster level *.env, use with care |
| 623 | source_local_envs |
| 624 | |
Petr Michalec | e9c8452 | 2017-12-13 17:14:08 +0100 | [diff] [blame] | 625 | saltservice_stop |
| 626 | |
| 627 | clone_reclass |
| 628 | |
projoke | 3c30e7d | 2017-10-19 17:15:40 +0800 | [diff] [blame] | 629 | SCRIPTS=$(dirname $0) |
Petr Michalec | e9c8452 | 2017-12-13 17:14:08 +0100 | [diff] [blame] | 630 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 631 | test -e ${SCRIPTS}/.salt-master-setup.sh.passed || { |
Adam Tengler | 035f24f | 2017-09-11 19:29:31 +0200 | [diff] [blame] | 632 | export MASTER_IP=${MASTER_IP:-127.0.0.1} |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 633 | export MINION_ID=${MASTER_HOSTNAME} |
| 634 | if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then |
| 635 | SALT_MASTER_SETUP_OUTPUT='/dev/stdout' |
| 636 | fi |
| 637 | # call local "setup() master" |
| 638 | #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then |
| 639 | if ! setup master; then |
| 640 | #cat /tmp/salt-master-setup.log |
| 641 | log_err "salt master setup() failed." |
| 642 | exit 1 |
| 643 | else |
| 644 | $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed |
| 645 | fi |
| 646 | } |
| 647 | |
Petr Michalec | 981f3cc | 2017-11-15 17:40:31 +0100 | [diff] [blame] | 648 | log_info "Install reclass" |
| 649 | install_reclass ${RECLASS_VERSION/dev*/develop} |
Petr Michalec | a6cd2bd | 2017-09-07 16:59:19 +0200 | [diff] [blame] | 650 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 651 | log_info "Re/starting salt services" |
Petr Michalec | e9c8452 | 2017-12-13 17:14:08 +0100 | [diff] [blame] | 652 | saltservice_restart |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 653 | } |
| 654 | |
| 655 | # Init salt master |
| 656 | saltmaster_init() { |
| 657 | |
| 658 | log_info "Runing saltmaster states" |
| 659 | test -n "$MASTER_HOSTNAME" || exit 1 |
| 660 | |
| 661 | set -e |
| 662 | $SUDO salt-call saltutil.sync_all >/dev/null |
| 663 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 664 | # workarond isolated and not fully bootstraped environments |
Petr Michalec | 2801acb | 2017-10-31 15:00:15 +0100 | [diff] [blame] | 665 | if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then |
Petr Michalec | 54ee408 | 2017-11-30 17:02:17 +0100 | [diff] [blame] | 666 | SALT_MASTER_PILLAR='"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": '${RECLASS_IGNORE_CLASS_NOTFOUND:-False}', "ignore_class_regexp": ["service.*"]}}}},' |
Petr Michalec | 2801acb | 2017-10-31 15:00:15 +0100 | [diff] [blame] | 667 | fi |
Petr Michalec | 8ce8a65 | 2017-11-30 15:39:20 +0100 | [diff] [blame] | 668 | PILLAR='{'${SALT_MASTER_PILLAR}' "reclass":{"storage":{"data_source":{"engine":"local"}}} }' |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 669 | |
Petr Michalec | 8b92d55 | 2017-11-29 12:28:50 +0100 | [diff] [blame] | 670 | log_info "State: salt.master.env,salt.master.pillar" |
Petr Michalec | 54ee408 | 2017-11-30 17:02:17 +0100 | [diff] [blame] | 671 | if ! $SUDO salt-call ${SALT_OPTS} state.apply salt.master.env,salt.master.pillar pillar="$PILLAR"; then |
Petr Michalec | 85ef7ad | 2017-11-30 15:21:19 +0100 | [diff] [blame] | 672 | log_err "State \`salt.master.env,salt.master.pillar pillar=$PILLAR\` failed, keep your eyes wide open!" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 673 | fi |
| 674 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 675 | # Revert temporary SaltMaster minimal configuration, if any |
| 676 | pushd $RECLASS_ROOT |
| 677 | if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then |
Petr Michalec | 87778fc | 2017-11-02 10:13:25 +0100 | [diff] [blame] | 678 | PILLAR='{"reclass":{"storage":{"data_source":{"engine":"local"}}} }' |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 679 | git status || true |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 680 | log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 681 | log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*." |
| 682 | git checkout -- $RECLASS_ROOT/nodes || true |
| 683 | log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state." |
Petr Michalec | 7edf832 | 2017-11-30 12:01:09 +0100 | [diff] [blame] | 684 | log_info "State: salt.master.env,salt.master.pillar" |
Petr Michalec | 54ee408 | 2017-11-30 17:02:17 +0100 | [diff] [blame] | 685 | if ! $SUDO salt-call ${SALT_OPTS} state.apply salt.master.env,salt.master.pillar pillar="$PILLAR"; then |
Petr Michalec | 85ef7ad | 2017-11-30 15:21:19 +0100 | [diff] [blame] | 686 | log_err "State \`salt.master.env,salt.master.pillar pillar=$PILLAR\` failed, keep your eyes wide open!" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 687 | fi |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 688 | fi |
| 689 | popd |
| 690 | |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 691 | # finally re-configure salt master conf, ie: may remove ignore_class_notfound option |
| 692 | log_info "State: salt.master.service" |
Jakub Josef | 3256341 | 2018-01-17 17:55:05 +0100 | [diff] [blame] | 693 | # ensure salt master is started |
| 694 | saltservice_start |
Petr Michalec | 9fec8b3 | 2017-10-05 14:46:42 +0200 | [diff] [blame] | 695 | retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true |
Petr Michalec | 4f04377 | 2017-12-19 15:40:54 +0100 | [diff] [blame] | 696 | saltservice_start |
Petr Michalec | da01420 | 2017-08-18 11:26:07 +0200 | [diff] [blame] | 697 | |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 698 | log_info "State: salt.master.storage.node" |
| 699 | set +e |
Petr Michalec | 7edf832 | 2017-11-30 12:01:09 +0100 | [diff] [blame] | 700 | # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT. |
| 701 | # FIXME: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT. |
Petr Michalec | 9fec8b3 | 2017-10-05 14:46:42 +0200 | [diff] [blame] | 702 | retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 703 | ret=$? |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 704 | |
Petr Michalec | dd646db | 2017-12-18 15:56:18 +0100 | [diff] [blame] | 705 | set -e |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 706 | if [[ $ret -eq 2 ]]; then |
| 707 | log_err "State reclass.storage.node failed with exit code 2 but continuing." |
| 708 | elif [[ $ret -ne 0 ]]; then |
| 709 | log_err "State reclass.storage.node failed with exit code $ret" |
| 710 | exit 1 |
| 711 | fi |
| 712 | |
Petr Michalec | dd646db | 2017-12-18 15:56:18 +0100 | [diff] [blame] | 713 | set +e |
| 714 | log_info "Updating minion.conf -> master: localhost" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 715 | $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf |
Petr Michalec | dd646db | 2017-12-18 15:56:18 +0100 | [diff] [blame] | 716 | |
| 717 | log_info "Re/starting salt services" # in order to load new deployed configuration from model |
Petr Michalec | e9c8452 | 2017-12-13 17:14:08 +0100 | [diff] [blame] | 718 | saltservice_restart |
Petr Michalec | dd646db | 2017-12-18 15:56:18 +0100 | [diff] [blame] | 719 | |
| 720 | log_info "Salt Util sync all" |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 721 | $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null |
| 722 | |
| 723 | verify_salt_master |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 724 | |
| 725 | } |
| 726 | |
| 727 | |
| 728 | function verify_salt_master() { |
| 729 | set -e |
| 730 | |
| 731 | log_info "Verify Salt master" |
| 732 | test -n "$MASTER_HOSTNAME" || exit 1 |
| 733 | |
| 734 | if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then |
Petr Michalec | a514134 | 2017-08-16 12:55:20 +0200 | [diff] [blame] | 735 | $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml |
| 736 | $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 737 | $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles |
| 738 | $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state |
| 739 | $SUDO salt-call --no-color grains.items |
| 740 | $SUDO salt-call --no-color pillar.data |
| 741 | fi |
Petr Michalec | a514134 | 2017-08-16 12:55:20 +0200 | [diff] [blame] | 742 | # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_* |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 743 | if ! $SUDO reclass --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then |
| 744 | log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo" |
| 745 | exit 1 |
| 746 | fi |
Petr Michalec | 7edf832 | 2017-11-30 12:01:09 +0100 | [diff] [blame] | 747 | set +e |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 748 | } |
| 749 | |
| 750 | function verify_salt_minion() { |
| 751 | set -e |
| 752 | node=$1 |
| 753 | log_info "Verifying ${node}" |
| 754 | if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then |
| 755 | $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles |
| 756 | $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate |
| 757 | fi |
| 758 | if ! $SUDO reclass --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then |
| 759 | log_err "For more details see full log /tmp/${node}.reclass.nodeinfo" |
| 760 | if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then |
| 761 | exit 1 |
| 762 | fi |
| 763 | fi |
Petr Michalec | 7edf832 | 2017-11-30 12:01:09 +0100 | [diff] [blame] | 764 | set +e |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 765 | } |
| 766 | |
| 767 | function verify_salt_minions() { |
| 768 | #set -e |
Petr Michalec | 679f15b | 2017-09-18 16:16:29 +0200 | [diff] [blame] | 769 | NODES=$(find $RECLASS_ROOT/nodes/_generated/ -name "*.yml" | grep -v "cfg") |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 770 | log_info "Verifying minions: $(echo ${NODES}|xargs)" |
| 771 | |
| 772 | # Parallel |
| 773 | #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify" |
| 774 | #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30 |
| 775 | |
| 776 | function filterFails() { |
| 777 | grep -v '/grains' | tee -a $1 | tail -n20 |
| 778 | } |
| 779 | |
| 780 | log_info "Verify nodes" |
| 781 | passed=0 |
| 782 | for node in ${NODES}; do |
| 783 | node=$(basename $node .yml) |
| 784 | |
| 785 | # filter first in cluster.. ctl-01, mon-01, etc.. |
| 786 | if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then |
| 787 | verify_salt_minion ${node} || continue |
| 788 | else |
| 789 | echo Skipped $node. |
| 790 | fi |
| 791 | passed=$(($passed+1)) |
| 792 | done |
| 793 | # fail on failures |
| 794 | total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l) |
| 795 | test ! $passed -lt $total || log_err "Results: $passed of $total passed." |
| 796 | test ! $passed -lt $total || { |
| 797 | tail -n50 /tmp/*.pillar_verify |
| 798 | return 1 |
| 799 | } |
Petr Michalec | 7edf832 | 2017-11-30 12:01:09 +0100 | [diff] [blame] | 800 | #set +e |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 801 | } |
| 802 | |
| 803 | |
| 804 | |
| 805 | ########################################## |
| 806 | # To install salt master/minon |
| 807 | |
| 808 | function install() { |
| 809 | setup $@ |
| 810 | } |
| 811 | |
| 812 | function setup() { |
| 813 | # CLI |
| 814 | while [ x"$1" != x"" ]; do |
| 815 | which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null |
| 816 | |
| 817 | case $1 in |
| 818 | master ) |
| 819 | install_salt_master_$SALT_SOURCE |
| 820 | install_salt_minion_$SALT_SOURCE |
| 821 | install_salt_formula_$FORMULAS_SOURCE |
| 822 | ;; |
| 823 | minion ) |
| 824 | install_salt_minion_$SALT_SOURCE |
| 825 | ;; |
| 826 | esac |
| 827 | shift |
| 828 | done |
| 829 | echo DONE |
| 830 | } |
| 831 | |
| 832 | function bootstrap() { |
| 833 | log_info "Bootstrap & verification of SaltMaster and configured minions." |
| 834 | trap _atexit INT TERM EXIT |
| 835 | |
| 836 | system_config_master |
| 837 | saltmaster_bootstrap &&\ |
Petr Michalec | 58575b9 | 2017-08-20 10:42:25 +0200 | [diff] [blame] | 838 | saltmaster_init #&&\ |
Petr Michalec | a514134 | 2017-08-16 12:55:20 +0200 | [diff] [blame] | 839 | #verify_salt_minions |
Petr Michalec | 1ed1b3c | 2017-08-08 19:19:01 +0200 | [diff] [blame] | 840 | } |
| 841 | |
| 842 | function default() { |
| 843 | bootstrap $@ |
| 844 | } |
| 845 | |
| 846 | |
| 847 | ########################################## |
| 848 | [[ "$0" != "$BASH_SOURCE" ]] || { |
| 849 | # unless file is being sourced |
| 850 | default $@ |
| 851 | } |